{
                               UNIDAD PARA TEXTO

                                     Maneja el modo $03 80 * 25, 16 colores
                               Copyright (c) 1997,98 Marco Antonio Alvarado

                                             Telfono: 219-21-76
                                      Apartado Postal: 318-1002
                                                       San Jos, Costa Rica
}

unit utexto;

interface

  uses
    uvbs;

  type
    pbyte = ^byte;
    ptexto2 = ^rtexto2;

    rtexto2 = record
      simbolo : char;
      color : byte;
    end;

    ppantalla = ^apantalla;
    apantalla = array [0..1999] of rtexto2;

  var
{Error:
  1 = el procesador no es 80386 o superior.
  2 = no puede poner el modo texto.}
    error : word;

  procedure espera;
  function copiasimbolo (punto : word) : char;
  function copiacolor (punto : word) : byte;
  procedure pegasimbolo (simbolo : char; punto : word);
  procedure pegacolor (color : byte; punto : word);
  procedure llenasimbolo (simbolo : char; punto, cantidad : word);
  procedure llenacolor (color : byte; punto, cantidad : word);
  procedure pegasimbolos (simbolos : pchar; punto, cantidad : word);
  procedure pegacolores (colores : pbyte; punto, cantidad : word);
  procedure copiasimbolos (punto : word; simbolos : pchar; cantidad : word);
  procedure copiacolores (punto : word; colores : pbyte; cantidad : word);
  procedure copiatexto (punto : word; texto : pbyte; cantidad : word);
  procedure pegatexto (texto : pbyte; punto, cantidad : word);
  procedure borrapantalla;
  procedure copiapantalla (pantalla : ppantalla);
  procedure pegapantalla (pantalla : ppantalla);

implementation

  const
    modo = $03;
    segmentopantalla = $b800;
    tamanooperando = $66;

  var
    viejomodo : byte;
    viejoexitproc : pointer;

  procedure espera; assembler;

    label
      ciclo1, ciclo2;

  asm
    mov dx, 3dah

    ciclo1:

    in al, dx;
    and al, 8;
    jnz ciclo1;

    ciclo2:

    in al, dx
    and al, 8
    jz ciclo2
  end;

  function copiasimbolo (punto : word) : char; assembler;
  asm
{Apunta a la direccin del punto.}
    mov bx, segmentopantalla
    mov es, bx
    mov bx, punto
    shl bx, 1

{Copia el simbolo.}
    seges mov al, [bx]
  end;

  function copiacolor (punto : word) : byte; assembler;
  asm
{Apunta a la direccin del punto.}
    mov bx, segmentopantalla
    mov es, bx
    mov bx, punto
    shl bx, 1
    inc bx

{Copia el simbolo.}
    seges mov al, [bx]
  end;

  procedure pegasimbolo (simbolo : char; punto : word); assembler;
  asm
{Apunta a la direccin del punto.}
    mov bx, segmentopantalla
    mov es, bx
    mov bx, punto
    shl bx, 1

{Pega el smbolo.}
    mov al, simbolo
    seges mov [bx], al
  end;

  procedure pegacolor (color : byte; punto : word); assembler;
  asm
{Apunta a la direccin del punto.}
    mov bx, segmentopantalla
    mov es, bx
    mov bx, punto
    shl bx, 1
    inc bx

{Pega el color.}
    mov al, color
    seges mov [bx], al
  end;

  procedure llenasimbolo (simbolo : char; punto, cantidad : word); assembler;

    label
      ciclo;

  asm
{Apunta a la direccin del punto como destino.}
    mov di, segmentopantalla
    mov es, di
    mov di, punto
    shl di, 1

{Llena con el smbolo.}
    mov al, simbolo
    mov cx, cantidad

    ciclo:

    stosb
    inc di
    loop ciclo
  end;

  procedure llenacolor (color : byte; punto, cantidad : word); assembler;

    label
      ciclo;

  asm
{Apunta a la direccin del punto como destino.}
    mov di, segmentopantalla
    mov es, di
    mov di, punto
    shl di, 1
    inc di

{Llena con el color.}
    mov al, color
    mov cx, cantidad

    ciclo:

    stosb
    inc di
    loop ciclo
  end;

  procedure pegasimbolos (simbolos : pchar; punto, cantidad : word);
    assembler;

    label
      ciclo;

  asm
    push ds

{Apunta a la direccin del punto como destino.}
    mov di, segmentopantalla
    mov es, di
    mov di, punto
    shl di, 1

    mov cx, cantidad

{Carga la fuente.}
    lds si, simbolos

{Llena con el smbolo.}
    ciclo:

    movsb
    inc di
    loop ciclo

    pop ds
  end;

  procedure pegacolores (colores : pbyte; punto, cantidad : word); assembler;

    label
      ciclo;

  asm
    push ds

{Apunta a la direccin del punto como destino.}
    mov di, segmentopantalla
    mov es, di
    mov di, punto
    shl di, 1
    inc di

    mov cx, cantidad

{Carga la fuente.}
    lds si, colores

{Llena con el color.}
    ciclo:

    movsb
    inc di
    loop ciclo

    pop ds
  end;

  procedure copiasimbolos (punto : word; simbolos : pchar; cantidad : word);
    assembler;

    label
      ciclo;

  asm
    push ds

{Carga el destino.}
    les di, simbolos

    mov cx, cantidad

{Apunta a la direccin del punto como fuente.}
    mov si, punto
    mov ax, segmentopantalla
    mov ds, ax
    shl si, 1

{Llena con el smbolo.}
    ciclo:

    movsb
    inc di
    loop ciclo

    pop ds
  end;

  procedure copiacolores (punto : word; colores : pbyte; cantidad : word);
    assembler;

    label
      ciclo;

  asm
    push ds

{Carga el destino.}
    les di, colores

    mov cx, cantidad

{Apunta a la direccin del punto como fuente.}
    mov si, punto
    mov ax, segmentopantalla
    mov ds, ax
    shl si, 1
    inc si

{Llena con el color.}
    ciclo:

    movsb
    inc di
    loop ciclo

    pop ds
  end;

  procedure copiatexto (punto : word; texto : pbyte; cantidad : word);
    assembler;
  asm
{Salva el registro DS para que no se pierdan las variables.}
    push ds

{Apunta al destino.}
    les di, texto

{Resuelve la cantidad de dobles palabras a copiar.}
    mov cx, cantidad
    mov dx, cx
    and dx, 3
    shr cx, 2

{Apunta a la direccin del punto como fuente.}
    mov bx, punto
    mov si, segmentopantalla
    mov ds, si
    mov si, bx

{Copia las dobles palabras.}
    db tamanooperando
    rep movsw

{Copia las letras que faltan.}
    mov cx, dx
    rep movsb

{Repone DS.}
    pop ds
  end;

  procedure pegatexto (texto : pbyte; punto, cantidad : word); assembler;
  asm
{Salva el registro DS para que no se pierdan las variables.}
    push ds

{Apunta a la direccin del punto como destino.}
    mov di, segmentopantalla
    mov es, di
    mov di, punto

{Resuelve la cantidad de dobles palabras a pegar.}
    mov cx, cantidad
    mov dx, cx
    and dx, 3
    shr cx, 2

{Apunta a la fuente.}
    lds si, texto

{Pega las dobles palabras.}
    db tamanooperando
    rep movsw

{Pega las letras que faltan.}
    mov cx, dx
    rep movsb

{Repone DS.}
    pop ds
  end;

  procedure borrapantalla; assembler;
  asm
{Carga 0 en el registro EAX.}
    db tamanooperando
    xor ax, ax

{Apunta al inicio de la pantalla como destino.}
    mov di, segmentopantalla
    mov es, di
    xor di, di

{Carga la cantidad de dobles palabras a pegar.}
    mov cx, 500

{Pega las dobles palabras.}
    db tamanooperando
    rep stosw
  end;

  procedure copiapantalla (pantalla : ppantalla); assembler;
  asm
{Salva DS para que no se pierdan las variables.}
    push ds

{Apunta al destino.}
    les di, pantalla

{Apunta al inicio de la pantalla como fuente.}
    mov si, segmentopantalla
    mov ds, si
    xor si, si

{Carga la cantidad de dobles palabras a copiar.}
    mov cx, 500

{Copia las dobles palabras.}
    db tamanooperando
    rep movsw

{Repone DS.}
    pop ds
  end;

  procedure pegapantalla (pantalla : ppantalla); assembler;
  asm
{Salva DS para que no se pierdan las variables.}
    push ds

{Apunta al inicio de la pantalla como destino.}
    mov di, segmentopantalla
    mov es, di
    xor di, di

{Apunta a la fuente.}
    lds si, pantalla

{Carga la cantidad de dobles palabras a pegar.}
    mov cx, 500

{Pega las dobles palabras.}
    db tamanooperando
    rep movsw

{Repone DS.}
    pop ds
  end;

{$f+}
  procedure sale;
{$f-}
  begin
    exitproc := viejoexitproc;

    uvbs. ponemodo (viejomodo);
  end;

begin
  error := 0;

  if test8086 < 2 then
  begin
    error := 1;
  end;

  viejomodo := uvbs. modoactual;
  espera;
  uvbs. ponemodo (modo);

  if uvbs. modoactual <> modo then
  begin
    error := 2;
  end;

  viejoexitproc := exitproc;
  exitproc := @sale;
end.